// $ANTLR 2.7.4: "eql_tree.g" -> "EQLBaseWalker.java"$

  package net.esper.eql.generated;
  import java.util.Stack;
  import org.apache.commons.logging.Log;
  import org.apache.commons.logging.LogFactory;

public interface EqlEvalTokenTypes {
	int EOF = 1;
	int NULL_TREE_LOOKAHEAD = 3;
	int IN_SET = 4;
	int BETWEEN = 5;
	int LIKE = 6;
	int REGEXP = 7;
	int ESCAPE = 8;
	int OR_EXPR = 9;
	int AND_EXPR = 10;
	int NOT_EXPR = 11;
	int EVERY_EXPR = 12;
	int WHERE = 13;
	int AS = 14;
	int SUM = 15;
	int AVG = 16;
	int MAX = 17;
	int MIN = 18;
	int COALESCE = 19;
	int MEDIAN = 20;
	int STDDEV = 21;
	int AVEDEV = 22;
	int COUNT = 23;
	int SELECT = 24;
	int CASE = 25;
	int CASE2 = 26;
	int ELSE = 27;
	int WHEN = 28;
	int THEN = 29;
	int END = 30;
	int FROM = 31;
	int OUTER = 32;
	int JOIN = 33;
	int LEFT = 34;
	int RIGHT = 35;
	int FULL = 36;
	int ON = 37;
	int IS = 38;
	int BY = 39;
	int GROUP = 40;
	int HAVING = 41;
	int DISTINCT = 42;
	int ALL = 43;
	int OUTPUT = 44;
	int EVENTS = 45;
	int SECONDS = 46;
	int MINUTES = 47;
	int FIRST = 48;
	int LAST = 49;
	int INSERT = 50;
	int INTO = 51;
	int ORDER = 52;
	int ASC = 53;
	int DESC = 54;
	int RSTREAM = 55;
	int ISTREAM = 56;
	int PATTERN = 57;
	int SQL = 58;
	int PREVIOUS = 59;
	int PRIOR = 60;
	int NUMERIC_PARAM_RANGE = 61;
	int NUMERIC_PARAM_LIST = 62;
	int NUMERIC_PARAM_FREQUENCY = 63;
	int FOLLOWED_BY_EXPR = 64;
	int ARRAY_PARAM_LIST = 65;
	int EVENT_FILTER_EXPR = 66;
	int EVENT_FILTER_NAME_TAG = 67;
	int EVENT_FILTER_IDENT = 68;
	int EVENT_FILTER_PARAM = 69;
	int EVENT_FILTER_RANGE = 70;
	int EVENT_FILTER_NOT_RANGE = 71;
	int EVENT_FILTER_IN = 72;
	int EVENT_FILTER_NOT_IN = 73;
	int EVENT_FILTER_BETWEEN = 74;
	int EVENT_FILTER_NOT_BETWEEN = 75;
	int CLASS_IDENT = 76;
	int GUARD_EXPR = 77;
	int OBSERVER_EXPR = 78;
	int VIEW_EXPR = 79;
	int PATTERN_INCL_EXPR = 80;
	int DATABASE_JOIN_EXPR = 81;
	int WHERE_EXPR = 82;
	int HAVING_EXPR = 83;
	int EVAL_BITWISE_EXPR = 84;
	int EVAL_AND_EXPR = 85;
	int EVAL_OR_EXPR = 86;
	int EVAL_EQUALS_EXPR = 87;
	int EVAL_NOTEQUALS_EXPR = 88;
	int EVAL_IDENT = 89;
	int SELECTION_EXPR = 90;
	int SELECTION_ELEMENT_EXPR = 91;
	int STREAM_EXPR = 92;
	int OUTERJOIN_EXPR = 93;
	int LEFT_OUTERJOIN_EXPR = 94;
	int RIGHT_OUTERJOIN_EXPR = 95;
	int FULL_OUTERJOIN_EXPR = 96;
	int GROUP_BY_EXPR = 97;
	int ORDER_BY_EXPR = 98;
	int ORDER_ELEMENT_EXPR = 99;
	int EVENT_PROP_EXPR = 100;
	int EVENT_PROP_SIMPLE = 101;
	int EVENT_PROP_MAPPED = 102;
	int EVENT_PROP_INDEXED = 103;
	int EVENT_LIMIT_EXPR = 104;
	int SEC_LIMIT_EXPR = 105;
	int MIN_LIMIT_EXPR = 106;
	int INSERTINTO_EXPR = 107;
	int INSERTINTO_EXPRCOL = 108;
	int CONCAT = 109;
	int LIB_FUNCTION = 110;
	int UNARY_MINUS = 111;
	int TIME_PERIOD = 112;
	int ARRAY_EXPR = 113;
	int DAY_PART = 114;
	int HOUR_PART = 115;
	int MINUTE_PART = 116;
	int SECOND_PART = 117;
	int MILLISECOND_PART = 118;
	int NOT_IN_SET = 119;
	int NOT_BETWEEN = 120;
	int NOT_LIKE = 121;
	int NOT_REGEXP = 122;
	int DBSELECT_EXPR = 123;
	int DBFROM_CLAUSE = 124;
	int DBWHERE_CLAUSE = 125;
	int WILDCARD_SELECT = 126;
	int INT_TYPE = 127;
	int LONG_TYPE = 128;
	int FLOAT_TYPE = 129;
	int DOUBLE_TYPE = 130;
	int STRING_TYPE = 131;
	int BOOL_TYPE = 132;
	int NULL_TYPE = 133;
	int NUM_INT = 134;
	int NUM_LONG = 135;
	int NUM_FLOAT = 136;
	int NUM_DOUBLE = 137;
	int MINUS = 138;
	int PLUS = 139;
	int LITERAL_true = 140;
	int LITERAL_false = 141;
	int LITERAL_null = 142;
	int STRING_LITERAL = 143;
	int QUOTED_STRING_LITERAL = 144;
	int IDENT = 145;
	int LPAREN = 146;
	int COMMA = 147;
	int RPAREN = 148;
	int EQUALS = 149;
	int STAR = 150;
	int DOT = 151;
	int LBRACK = 152;
	int RBRACK = 153;
	int COLON = 154;
	int BAND = 155;
	int BOR = 156;
	int BXOR = 157;
	int SQL_NE = 158;
	int NOT_EQUAL = 159;
	int LT = 160;
	int GT = 161;
	int LE = 162;
	int GE = 163;
	int LOR = 164;
	int DIV = 165;
	int MOD = 166;
	int LCURLY = 167;
	int RCURLY = 168;
	int FOLLOWED_BY = 169;
	int LITERAL_days = 170;
	int LITERAL_day = 171;
	int LITERAL_hours = 172;
	int LITERAL_hour = 173;
	int LITERAL_minute = 174;
	int LITERAL_second = 175;
	int LITERAL_sec = 176;
	int LITERAL_milliseconds = 177;
	int LITERAL_millisecond = 178;
	int LITERAL_msec = 179;
	int QUESTION = 180;
	int EQUAL = 181;
	int LNOT = 182;
	int BNOT = 183;
	int DIV_ASSIGN = 184;
	int PLUS_ASSIGN = 185;
	int INC = 186;
	int MINUS_ASSIGN = 187;
	int DEC = 188;
	int STAR_ASSIGN = 189;
	int MOD_ASSIGN = 190;
	int SR = 191;
	int SR_ASSIGN = 192;
	int BSR = 193;
	int BSR_ASSIGN = 194;
	int SL = 195;
	int SL_ASSIGN = 196;
	int BXOR_ASSIGN = 197;
	int BOR_ASSIGN = 198;
	int BAND_ASSIGN = 199;
	int LAND = 200;
	int SEMI = 201;
	int WS = 202;
	int SL_COMMENT = 203;
	int ML_COMMENT = 204;
	int ESC = 205;
	int HEX_DIGIT = 206;
	int EXPONENT = 207;
	int FLOAT_SUFFIX = 208;
	int BOGUS = 209;
	int NUMERIC_PARAM_FREQUENCE = 210;
}
